//
//	XNvgv[[AvP[V
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#include "StdAfx.h"
#include "ScrPlay.h"
#include "resource.h"

//
// AvP[ṼCX^X
//
CScrPlayApp	theApp;

//
// RXgN^
//
CScrPlayApp::CScrPlayApp()
{
	hMutex = 0;
}

//
// fXgN^
//
CScrPlayApp::~CScrPlayApp()
{
	if (hMutex)
		::CloseHandle(hMutex);
}

//
// AvP[V
//
BOOL CScrPlayApp::InitInstance()
{
	// AvP[V̑dNh~
	if ((hMutex = ::CreateMutex(NULL, FALSE, ApplicationName "_Running")) == NULL)
		return FALSE;

	DWORD	Ret = ::WaitForSingleObject(hMutex, 0);
	if (Ret == WAIT_TIMEOUT || Ret == WAIT_FAILED)
		return FALSE;

	// nCJ[tJ[ȊOł̋Nh~
	HDC		dc = GetDC(0);
	int		nbits = GetDeviceCaps(dc, BITSPIXEL);
	ReleaseDC(0, dc);

	if (nbits < 15) {
		::MessageBox(0, "256Fȉł̓vCł܂B\nʃ[hύXĂB",
			ApplicationTitle, MB_ICONSTOP|MB_OK);
		return FALSE;
	}

	// CEChE̍쐬
	if (!MainWin.Create(this, ApplicationTitle, LoadMenu(IDC_APPMENU)))
		return FALSE;

	MainWnd = &MainWin;

	return TRUE;
}
