//
//	t[[NiDC bpj
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#include "StdAfx.h"
#include "Window.h"
#include "Misc.h"
#include "dc.h"

//
// CDCfXgN^
//
CDC::~CDC()
{
}

//
// CClientDCRXgN^
//
CClientDC::CClientDC(CWindow *win)
{
	hWnd = *win;
	hDC = ::GetDC(hWnd);
}

//
// CClientDCfXgN^
//
CClientDC::~CClientDC()
{
	::ReleaseDC(hWnd, hDC);
}

//
// CPaintDCRXgN^
//
CPaintDC::CPaintDC(CWindow *win)
{
	hWnd = *win;
	hDC = ::BeginPaint(hWnd, &ps);
}

//
// CPaintDCfXgN^
//
CPaintDC::~CPaintDC()
{
	::EndPaint(hWnd, &ps);
}

//
// CMemoryDCRXgN^
//
CMemoryDC::CMemoryDC(HDC hdc)
{
	hDC = ::CreateCompatibleDC(hdc);
}

//
// CMemoryDCfXgN^
//
CMemoryDC::~CMemoryDC()
{
	::DeleteDC(hDC);
}

//
// CScreenDCRXgN^
//
CScreenDC::CScreenDC()
{
	hDC = ::GetDC(0);
}

//
// CScreenDCfXgN^
//
CScreenDC::~CScreenDC()
{
	::ReleaseDC(0, hDC);
}
