//
//	XNvgRo[^
//
//		Copyright (c) 2000-2002 Chihiro.SAKAMOTO (HyperWorks)
//
#include "StdAfx.h"
#include "Reader.h"

//
// RXgN^
//
//	t@CI[v̎sIsOpen()gĔ
//
FileReader::FileReader(const char *name)
	:filename(name), lineno(0), fp(0)
{
	fp = fopen(name, "r");
}

//
// fXgN^
//
FileReader::~FileReader()
{
	if (fp)
		fclose(fp);
}

//
// 1s̓ǂݍ
//
const char *FileReader::GetString()
{
	lineno++;
	if (fgets(read_buffer, sizeof(read_buffer), fp) == NULL)
		return NULL;

	int	len = strlen(read_buffer);
	if (len > 0 && read_buffer[len-1] == '\n')
		read_buffer[len-1] = '\0';

	return read_buffer;
}
