# coding: shift_jis

import sys
import getopt

import paths
from Mailman import mm_cfg
from Mailman.i18n import _
from Mailman.Errors import NotAMemberError



def usage(code, msg=''):
    print _(__doc__.replace('%', '%%'))
    if msg:
        print msg
    sys.exit(code)


def changeoptions(mlist, addr, opnum):
    try:
        mlist.Lock()
        mlist.user_options[addr] = opnum
        mlist.Save()
        mlist.Unlock()
    except NotAMember:
        print 'AhX܂:', addr


def main():
    parser, opts, args = parseargs()
    changeoptions(parser, opts, args)


if __name__ == '__main__':
    usage(0)
